//
// The gamma-epsilon test is invoked whenever phi is found
// to increase, even though gamma is less than gamma_critical
// (usually 45 degrees).  This can happen when the minimum of
// the phi-surface is quite flat, and we have made lambda fairly
// large.  The assumption is that the step-size is too large, so
// this test reduces the step size by a factor of 2, and sees
// whether the new db passes the epsilon test.  If so, the
// gamma-epsilon test is passed and a 1 is returned.  Otherwise
// a 0 is returned.  The gamma-epsilon test may be invoked more
// than once on any given iteration; eventually either the test
// is passed or phi <= phi_old.
//

#include "fit.h"

int gam_eps_test(dbl* b, dbl* bs, dbl* db, dbl* sf, int npar)
{
    fail_pass k = fail;

    cerr << "\ntrying gam_eps_test...\n";
    for (int j = 0 ; j < npar ; j++) {
        db[j] *= 0.5;
        b[j] = bs[j] + db[j];
    }

    if (eps_test(b, db, sf, npar))
        k = pass;

    return k;
}

