//
// reads datafile, and returns the number of data points
// datafile comment lines have "#" at any position
//

#include "fit.h"

// #include <string>  // do not seem to need

int get_npts(char** argv)
{
    extern int optind;
    int n = 0;                          // datafile data line number
    string        line;
    ifstream    ifs;                    // input file stream

    ifs.open(argv[optind]);
    if (!ifs) {
        err("couldn't find an input datafile called \"",
             argv[optind], "\".");
    }
    while (getline(ifs, line)) {
        if (line.find("#") < maxlen) {  // comment line
            continue;                   // so ignore it
        }
        n++;                            // count the lines
    }

    ifs.close();
    return n;
}
