//
// new_a - calculates ptp matrix a and gradient vector g
//

#include "fit.h"

void new_a(dbl* x, dbl* s, dbl* r, dbl* b, dbl* p,\
           dbl* g, dbl** a, misc* mp, int npts)
{
    dbl w;
    int i, j, k;

// initialize to zero

    for (j = 0 ; j < mp->npar ; j++) {
        g[j] = 0.0;
        for (k = 0 ; k < mp->npar ; k++)
            a[j][k] = 0.0;
    }

// calculate g and a

    for (i = 0 ; i < npts ; i++) {
        func(x, b, p, 0, mp, i, 2);         // gets the p[i,k]
        w = 1.0/(s[i]*s[i]);                // weighting factor

        for (k = 0 ; k < mp->npar ; k++) {
            g[k] -= w * r[i] * p[k];        // gradient vector
            for (j = 0 ; j < mp->npar ; j++)
                a[j][k] += w * p[j] * p[k]; // A-matrix
        }
    }
}

